package wssessions

import (
	"clickandjoin.app/managementsystem/modules/scylladb"
	"clickandjoin.app/managementsystem/modules/structs"
	gocnjhelper "git.clickandjoin.umbach.dev/ClickandJoin/go-cnj-helper"
	"git.clickandjoin.umbach.dev/ClickandJoin/go-cnj-helper/dbstructs"
	"github.com/gofiber/fiber/v2"
)

func GetAllWsSessions(c *fiber.Ctx) error {
	// swagger:operation GET /wssessions wssessions wssessionsGetAllWsSessions
	// ---
	// summary: List of websocket sessions
	// consumes:
	// - application/json
	// produces:
	// - application/json
	// responses:
	//  '200':
	//    description: List of websocket sessions
	//    schema:
	//      "$ref": "#/definitions/UserWebSocketSessionsResponse"
	//  '500':
	//    description: Internal server error

	var wsSessions []dbstructs.UserWebSocketSession

	q := scylladb.Session.Query(gocnjhelper.DbMWebSocketSessions.SelectAll())

	if err := q.SelectRelease(&wsSessions); err != nil {
		gocnjhelper.LogErrorf("Failed to get ws sessions, err: %s", err)
	}

	return c.JSON(structs.WebSocketSessionsResponse{WsSessions: wsSessions})
}
